% Initialisation file for all states and parameters related to the
% BSM2 system.
% The state values are set to the latest previous simulation results.
% Internal controller and actuator states are not initialised.
%
% Copyright: Ulf Jeppsson, IEA, Lund University, Lund, Sweden

[m n] = size(reac1);

%Hydraulic delay at the input to the activated sludge 
S_I_ASin = ASinput(m,1);
S_S_ASin = ASinput(m,2);
X_I_ASin = ASinput(m,3);
X_S_ASin = ASinput(m,4);
X_BH_ASin = ASinput(m,5);
X_BA_ASin = ASinput(m,6);
X_P_ASin = ASinput(m,7);
S_O_ASin = ASinput(m,8);
S_NO_ASin = ASinput(m,9);
S_NH_ASin = ASinput(m,10);
S_ND_ASin = ASinput(m,11);
X_ND_ASin = ASinput(m,12);
S_ALK_ASin = ASinput(m,13);
TSS_ASin = ASinput(m,14);
Q_ASin = ASinput(m,15);
T_ASin = ASinput(m,16);
S_D1_ASin = ASinput(m,17);
S_D2_ASin = ASinput(m,18);
S_D3_ASin = ASinput(m,19);
X_D4_ASin = ASinput(m,20);
X_D5_ASin = ASinput(m,21);

%Hydraulic delay at the input to the primary clarifier 
S_I_Pin = primaryinput(m,1);
S_S_Pin = primaryinput(m,2);
X_I_Pin = primaryinput(m,3);
X_S_Pin = primaryinput(m,4);
X_BH_Pin = primaryinput(m,5);
X_BA_Pin = primaryinput(m,6);
X_P_Pin = primaryinput(m,7);
S_O_Pin = primaryinput(m,8);
S_NO_Pin = primaryinput(m,9);
S_NH_Pin = primaryinput(m,10);
S_ND_Pin = primaryinput(m,11);
X_ND_Pin = primaryinput(m,12);
S_ALK_Pin = primaryinput(m,13);
TSS_Pin = primaryinput(m,14);
Q_Pin = primaryinput(m,15);
T_Pin = primaryinput(m,16);
S_D1_Pin = primaryinput(m,17);
S_D2_Pin = primaryinput(m,18);
X_D4_Pin = primaryinput(m,20);
S_D3_Pin = primaryinput(m,19);
X_D5_Pin = primaryinput(m,21);

%Primary clarifier  
S_I_P =  primaryout(m,43);
S_S_P =  primaryout(m,44);
X_I_P =  primaryout(m,45);
X_S_P =  primaryout(m,46);
X_BH_P = primaryout(m,47);
X_BA_P = primaryout(m,48);
X_P_P =  primaryout(m,49);
S_O_P =  primaryout(m,50);
S_NO_P = primaryout(m,51);
S_NH_P = primaryout(m,52);
S_ND_P = primaryout(m,53);
X_ND_P = primaryout(m,54);
S_ALK_P = primaryout(m,55);
TSS_P = primaryout(m,56);
Q_P = primaryout(m,57);
T_P = primaryout(m,58);
S_D1_P = primaryout(m,59);
S_D2_P = primaryout(m,60);
S_D3_P = primaryout(m,61);
X_D4_P = primaryout(m,62);
X_D5_P = primaryout(m,63);

%Activated sludge reactors  
S_I1 = reac1(m,1);
S_S1 = reac1(m,2);
X_I1 = reac1(m,3);
X_S1 = reac1(m,4);
X_BH1 = reac1(m,5);
X_BA1 = reac1(m,6);
X_P1 = reac1(m,7);
S_O1 = reac1(m,8);
S_NO1 = reac1(m,9);
S_NH1 = reac1(m,10);
S_ND1 = reac1(m,11);
X_ND1 = reac1(m,12);
S_ALK1 = reac1(m,13);
TSS1 = reac1(m,14);
Q1 = reac1(m,15);
T1 = reac1(m,16);
S_D1_1 = reac1(m,17);
S_D2_1 = reac1(m,18);
S_D3_1 = reac1(m,19);
X_D4_1 = reac1(m,20);
X_D5_1 = reac1(m,21);

S_I2 = reac2(m,1);
S_S2 = reac2(m,2);
X_I2 = reac2(m,3);
X_S2 = reac2(m,4);
X_BH2 = reac2(m,5);
X_BA2 = reac2(m,6);
X_P2 = reac2(m,7);
S_O2 = reac2(m,8);
S_NO2 = reac2(m,9);
S_NH2 = reac2(m,10);
S_ND2 = reac2(m,11);
X_ND2 = reac2(m,12);
S_ALK2 = reac2(m,13);
TSS2 = reac2(m,14);
Q2 = reac2(m,15);
T2 = reac2(m,16);
S_D1_2 = reac2(m,17);
S_D2_2 = reac2(m,18);
S_D3_2 = reac2(m,19);
X_D4_2 = reac2(m,20);
X_D5_2 = reac2(m,21);

S_I3 = reac3(m,1);
S_S3 = reac3(m,2);
X_I3 = reac3(m,3);
X_S3 = reac3(m,4);
X_BH3 = reac3(m,5);
X_BA3 = reac3(m,6);
X_P3 = reac3(m,7);
S_O3 = reac3(m,8);
S_NO3 = reac3(m,9);
S_NH3 = reac3(m,10);
S_ND3 = reac3(m,11);
X_ND3 = reac3(m,12);
S_ALK3 = reac3(m,13);
TSS3 = reac3(m,14);
Q3 = reac3(m,15);
T3 = reac3(m,16);
S_D1_3 = reac3(m,17);
S_D2_3 = reac3(m,18);
S_D3_3 = reac3(m,19);
X_D4_3 = reac3(m,20);
X_D5_3 = reac3(m,21);

S_I4 = reac4(m,1);
S_S4 = reac4(m,2);
X_I4 = reac4(m,3);
X_S4 = reac4(m,4);
X_BH4 = reac4(m,5);
X_BA4 = reac4(m,6);
X_P4 = reac4(m,7);
S_O4 = reac4(m,8);
S_NO4 = reac4(m,9);
S_NH4 = reac4(m,10);
S_ND4 = reac4(m,11);
X_ND4 = reac4(m,12);
S_ALK4 = reac4(m,13);
TSS4 = reac4(m,14);
Q4 = reac4(m,15);
T4 = reac4(m,16);
S_D1_4 = reac4(m,17);
S_D2_4 = reac4(m,18);
S_D3_4 = reac4(m,19);
X_D4_4 = reac4(m,20);
X_D5_4 = reac4(m,21);

S_I5 = reac5(m,1);
S_S5 = reac5(m,2);
X_I5 = reac5(m,3);
X_S5 = reac5(m,4);
X_BH5 = reac5(m,5);
X_BA5 = reac5(m,6);
X_P5 = reac5(m,7);
S_O5 = reac5(m,8);
S_NO5 = reac5(m,9);
S_NH5 = reac5(m,10);
S_ND5 = reac5(m,11);
X_ND5 = reac5(m,12);
S_ALK5 = reac5(m,13);
TSS5 = reac5(m,14);
Q5 = reac5(m,15);
T5 = reac5(m,16);
S_D1_5 = reac5(m,17);
S_D2_5 = reac5(m,18);
S_D3_5 = reac5(m,19);
X_D4_5 = reac5(m,20);
X_D5_5 = reac5(m,21);


%Settler states 
TSS_1 = settler(m,44);
TSS_2 = settler(m,45);
TSS_3 = settler(m,46);
TSS_4 = settler(m,47);
TSS_5 = settler(m,48);
TSS_6 = settler(m,49);
TSS_7 = settler(m,50);
TSS_8 = settler(m,51);
TSS_9 = settler(m,52);
TSS_10 = settler(m,53);

SI_1 = settler(m,56);
SI_2 = settler(m,57);
SI_3 = settler(m,58);
SI_4 = settler(m,59);
SI_5 = settler(m,60);
SI_6 = settler(m,61);
SI_7 = settler(m,62);
SI_8 = settler(m,63);
SI_9 = settler(m,64);
SI_10 = settler(m,65);

SS_1 = settler(m,66);
SS_2 = settler(m,67);
SS_3 = settler(m,68);
SS_4 = settler(m,69);
SS_5 = settler(m,70);
SS_6 = settler(m,71);
SS_7 = settler(m,72);
SS_8 = settler(m,73);
SS_9 = settler(m,74);
SS_10 = settler(m,75);

SO_1 = settler(m,76);
SO_2 = settler(m,77);
SO_3 = settler(m,78);
SO_4 = settler(m,79);
SO_5 = settler(m,80);
SO_6 = settler(m,81);
SO_7 = settler(m,82);
SO_8 = settler(m,83);
SO_9 = settler(m,84);
SO_10 = settler(m,85);

SNO_1 = settler(m,86);
SNO_2 = settler(m,87);
SNO_3 = settler(m,88);
SNO_4 = settler(m,89);
SNO_5 = settler(m,90);
SNO_6 = settler(m,91);
SNO_7 = settler(m,92);
SNO_8 = settler(m,93);
SNO_9 = settler(m,94);
SNO_10 = settler(m,95);

SNH_1 = settler(m,96);
SNH_2 = settler(m,97);
SNH_3 = settler(m,98);
SNH_4 = settler(m,99);
SNH_5 = settler(m,100);
SNH_6 = settler(m,101);
SNH_7 = settler(m,102);
SNH_8 = settler(m,103);
SNH_9 = settler(m,104);
SNH_10 = settler(m,105);

SND_1 = settler(m,106);
SND_2 = settler(m,107);
SND_3 = settler(m,108);
SND_4 = settler(m,109);
SND_5 = settler(m,110);
SND_6 = settler(m,111);
SND_7 = settler(m,112);
SND_8 = settler(m,113);
SND_9 = settler(m,114);
SND_10 = settler(m,115);

SALK_1 = settler(m,116);
SALK_2 = settler(m,117);
SALK_3 = settler(m,118);
SALK_4 = settler(m,119);
SALK_5 = settler(m,120);
SALK_6 = settler(m,121);
SALK_7 = settler(m,122);
SALK_8 = settler(m,123);
SALK_9 = settler(m,124);
SALK_10 = settler(m,125);

SD1_1 = settler(m,126);
SD1_2 = settler(m,127);
SD1_3 = settler(m,128);
SD1_4 = settler(m,129);
SD1_5 = settler(m,130);
SD1_6 = settler(m,131);
SD1_7 = settler(m,132);
SD1_8 = settler(m,133);
SD1_9 = settler(m,134);
SD1_10 = settler(m,135);

SD2_1 = settler(m,136);
SD2_2 = settler(m,137);
SD2_3 = settler(m,138);
SD2_4 = settler(m,139);
SD2_5 = settler(m,140);
SD2_6 = settler(m,141);
SD2_7 = settler(m,142);
SD2_8 = settler(m,143);
SD2_9 = settler(m,144);
SD2_10 = settler(m,145);

SD3_1 = settler(m,146);
SD3_2 = settler(m,147);
SD3_3 = settler(m,148);
SD3_4 = settler(m,149);
SD3_5 = settler(m,150);
SD3_6 = settler(m,151);
SD3_7 = settler(m,152);
SD3_8 = settler(m,153);
SD3_9 = settler(m,154);
SD3_10 = settler(m,155);

T_1 = settler(m,156);
T_2 = settler(m,157);
T_3 = settler(m,158);
T_4 = settler(m,159);
T_5 = settler(m,160);
T_6 = settler(m,161);
T_7 = settler(m,162);
T_8 = settler(m,163);
T_9 = settler(m,164);
T_10 = settler(m,165);


%Anaerobic digester
S_su = digesterout(m,1);
S_aa = digesterout(m,2);
S_fa = digesterout(m,3);
S_va = digesterout(m,4);
S_bu = digesterout(m,5);
S_pro = digesterout(m,6);
S_ac = digesterout(m,7);
S_h2 = digesterout(m,8);
S_ch4 = digesterout(m,9);
S_IC = digesterout(m,10);
S_IN = digesterout(m,11);
S_I = digesterout(m,12);
X_xc = digesterout(m,13);
X_ch = digesterout(m,14);
X_pr = digesterout(m,15);
X_li = digesterout(m,16);
X_su = digesterout(m,17);
X_aa = digesterout(m,18);
X_fa = digesterout(m,19);
X_c4 = digesterout(m,20);
X_pro = digesterout(m,21);
X_ac = digesterout(m,22);
X_h2 = digesterout(m,23);
X_I = digesterout(m,24);
S_cat = digesterout(m,25);
S_an = digesterout(m,26);
S_hva = digesterout(m,36);
S_hbu = digesterout(m,37);
S_hpro = digesterout(m,38);
S_hac = digesterout(m,39);
S_hco3 = digesterout(m,40);
S_nh3 = digesterout(m,42);
S_gas_h2 = digesterout(m,44);
S_gas_ch4 = digesterout(m,45);
S_gas_co2 = digesterout(m,46);
Q_D = digesterout(m,27);
T_D = digesterout(m,28);
S_D1_D = digesterout(m,29);
S_D2_D = digesterout(m,30);
S_D3_D = digesterout(m,31);
X_D4_D = digesterout(m,32);
X_D5_D = digesterout(m,33);
PHINIT = digesterout(m,34);
S_H_ion = digesterout(m,35);

% Storage tank
S_I_S =  storageout(m,1);
S_S_S =  storageout(m,2);
X_I_S =  storageout(m,3);
X_S_S =  storageout(m,4);
X_BH_S = storageout(m,5);
X_BA_S = storageout(m,6);
X_P_S =  storageout(m,7);
S_O_S =  storageout(m,8);
S_NO_S = storageout(m,9);
S_NH_S = storageout(m,10);
S_ND_S = storageout(m,11);
X_ND_S = storageout(m,12);
S_ALK_S = storageout(m,13);
TSS_S = storageout(m,14);
Q_S = storageout(m,15);
T_S = storageout(m,16);
S_D1_S = storageout(m,17);
S_D2_S = storageout(m,18);
S_D3_S = storageout(m,19);
X_D4_S = storageout(m,20);
X_D5_S = storageout(m,21);
VOL_INIT_S = storageout(m,22);


% set initial value vectors for all models
XINITDELAY = [ S_I_ASin  S_S_ASin  X_I_ASin  X_S_ASin  X_BH_ASin  X_BA_ASin  X_P_ASin  S_O_ASin  S_NO_ASin  S_NH_ASin  S_ND_ASin  X_ND_ASin  S_ALK_ASin TSS_ASin Q_ASin T_ASin S_D1_ASin S_D2_ASin S_D3_ASin X_D4_ASin X_D5_ASin ];

XINITDELAYPRIMARY = [ S_I_Pin  S_S_Pin  X_I_Pin  X_S_Pin  X_BH_Pin  X_BA_Pin  X_P_Pin  S_O_Pin  S_NO_Pin  S_NH_Pin  S_ND_Pin  X_ND_Pin  S_ALK_Pin TSS_Pin Q_Pin T_Pin S_D1_Pin S_D2_Pin S_D3_Pin X_D4_Pin X_D5_Pin ];

XINITPRIMARY = [ S_I_P  S_S_P  X_I_P  X_S_P  X_BH_P  X_BA_P  X_P_P  S_O_P  S_NO_P  S_NH_P  S_ND_P  X_ND_P  S_ALK_P TSS_P Q_P T_P S_D1_P S_D2_P S_D3_P X_D4_P X_D5_P ];

XINIT1 = [ S_I1  S_S1  X_I1  X_S1  X_BH1  X_BA1  X_P1  S_O1  S_NO1  S_NH1  S_ND1  X_ND1  S_ALK1 TSS1 Q1 T1 S_D1_1 S_D2_1 S_D3_1 X_D4_1 X_D5_1 ];
XINIT2 = [ S_I2  S_S2  X_I2  X_S2  X_BH2  X_BA2  X_P2  S_O2  S_NO2  S_NH2  S_ND2  X_ND2  S_ALK2 TSS2 Q2 T2 S_D1_2 S_D2_2 S_D3_2 X_D4_2 X_D5_2 ];
XINIT3 = [ S_I3  S_S3  X_I3  X_S3  X_BH3  X_BA3  X_P3  S_O3  S_NO3  S_NH3  S_ND3  X_ND3  S_ALK3 TSS3 Q3 T3 S_D1_3 S_D2_3 S_D3_3 X_D4_3 X_D5_3 ];
XINIT4 = [ S_I4  S_S4  X_I4  X_S4  X_BH4  X_BA4  X_P4  S_O4  S_NO4  S_NH4  S_ND4  X_ND4  S_ALK4 TSS4 Q4 T4 S_D1_4 S_D2_4 S_D3_4 X_D4_4 X_D5_4 ];
XINIT5 = [ S_I5  S_S5  X_I5  X_S5  X_BH5  X_BA5  X_P5  S_O5  S_NO5  S_NH5  S_ND5  X_ND5  S_ALK5 TSS5 Q5 T5 S_D1_5 S_D2_5 S_D3_5 X_D4_5 X_D5_5 ];

SETTLERINIT = [ TSS_1 TSS_2 TSS_3 TSS_4 TSS_5 TSS_6 TSS_7 TSS_8 TSS_9 TSS_10  SI_1 SI_2 SI_3 SI_4 SI_5 SI_6 SI_7 SI_8 SI_9 SI_10  SS_1 SS_2 SS_3 SS_4 SS_5 SS_6 SS_7 SS_8 SS_9 SS_10  SO_1 SO_2 SO_3 SO_4 SO_5 SO_6 SO_7 SO_8 SO_9 SO_10  SNO_1 SNO_2 SNO_3 SNO_4 SNO_5 SNO_6 SNO_7 SNO_8 SNO_9 SNO_10  SNH_1 SNH_2 SNH_3 SNH_4 SNH_5 SNH_6 SNH_7 SNH_8 SNH_9 SNH_10 SND_1 SND_2 SND_3 SND_4 SND_5 SND_6 SND_7 SND_8 SND_9 SND_10  SALK_1 SALK_2 SALK_3 SALK_4 SALK_5 SALK_6 SALK_7 SALK_8 SALK_9 SALK_10 ... 
                SD1_1 SD1_2 SD1_3 SD1_4 SD1_5 SD1_6 SD1_7 SD1_8 SD1_9 SD1_10 SD2_1 SD2_2 SD2_3 SD2_4 SD2_5 SD2_6 SD2_7 SD2_8 SD2_9 SD2_10 SD3_1 SD3_2 SD3_3 SD3_4 SD3_5 SD3_6 SD3_7 SD3_8 SD3_9 SD3_10 T_1 T_2 T_3 T_4 T_5 T_6 T_7 T_8 T_9 T_10 ];

DIGESTERINIT = [ S_su S_aa S_fa S_va S_bu S_pro S_ac S_h2 S_ch4 S_IC S_IN S_I X_xc X_ch X_pr X_li X_su X_aa X_fa X_c4 X_pro X_ac X_h2 ... 
                 X_I S_cat S_an S_hva S_hbu S_hpro S_hac S_hco3 S_nh3 S_gas_h2 S_gas_ch4 S_gas_co2 Q_D T_D S_D1_D S_D2_D S_D3_D X_D4_D X_D5_D ];
             
PHSOLVINIT = [ S_H_ion S_hva S_hbu S_hpro S_hac S_hco3 S_nh3 ];

SH2SOLVINIT = [ S_h2 ];

XINITSTORAGE = [ S_I_S  S_S_S  X_I_S  X_S_S  X_BH_S  X_BA_S  X_P_S  S_O_S  S_NO_S  S_NH_S  S_ND_S  X_ND_S  S_ALK_S TSS_S Q_S T_S S_D1_S S_D2_S S_D3_S X_D4_S X_D5_S VOL_INIT_S ];

Qintr = rec(m,15);
Qr = settler(m,15);
Qw = settler(m,22);
Sludge_blanket = settler(m,166);

save states_bsm2.mat Qintr Qr Qw Sludge_blanket XINITDELAY XINITDELAYPRIMARY XINITPRIMARY XINIT1 XINIT2 XINIT3 XINIT4 XINIT5 SETTLERINIT DIGESTERINIT PHSOLVINIT SH2SOLVINIT XINITSTORAGE